#pragma once

#include "codec_gen.hh"
#include "params.hh"

class Base_Type;
class TTCN_Typedescriptor_t;
class TTCN_Buffer;

namespace LibHttp__XmlMessageBodyTypes {
  class XmlBody;
}

class xml_codec: public codec_gen<LibHttp__XmlMessageBodyTypes::XmlBody, LibHttp__XmlMessageBodyTypes::XmlBody>
{
  //TITAN issue: variant "namespace for 'agent/organization' seems buggy: <Agent xsi:type="agent:Organization"> instead of xsi:type=\"ns6:Agent\" xmlns:ns6=\"http://www.cise.eu/datamodel/v1/entity/organization/
  int patch_encode_agent_derivations(std::string& s);
  int patch_encode_location_derivations(std::string& s);
  int patch_encode_event_derivations(std::string& s);
  int patch_encode_object_derivations(std::string& s);
  int patch_encode_document_derivations(std::string& s);
  int patch_encode_service_capability_derivations(std::string& s);
  int patch_decode_service_capability_derivations(std::string& s);
  //TITAN issue: variant "namespace for 'agent/organization' seems buggy: <Agent xsi:type="agent:Organization"> instead of xsi:type=\"ns6:Agent\" xmlns:ns6=\"http://www.cise.eu/datamodel/v1/entity/organization/
public:
  explicit xml_codec() : codec_gen<LibHttp__XmlMessageBodyTypes::XmlBody, LibHttp__XmlMessageBodyTypes::XmlBody>() { };
  virtual ~xml_codec() { };

  virtual int encode (const LibHttp__XmlMessageBodyTypes::XmlBody&, OCTETSTRING& data);
  virtual int decode (const OCTETSTRING& p_data, LibHttp__XmlMessageBodyTypes::XmlBody&, params* p_params = NULL);

}; // End of class xml_codec
