#include "LibCise_Functions.hh"

#include "loggers.hh"

//#include <vector>
//#include <iostream>
#include <sstream>
#include <iomanip>
#include <random>
//#include <climits>
//#include <algorithm>
//#include <functional>
#include <string>
#include <ctime>

#include "xml_codec.hh"

namespace LibCise__Functions {

  BITSTRING fx__enc__PullRequest__1(const http__www__cise__eu__servicemodel__v1__message::PullRequest& p) { // FIXME Use enc/dec TITAN function external function f_enc_value(in Value x) return bitstring with { extension "prototype(convert) encode(abc)" }
    loggers::get_instance().log(">>> fx__enc__PullRequest");

    LibHttp__XmlMessageBodyTypes::XmlBody msg;
    msg.msg().pull__request() = p;
    msg.raw().set_to_omit();
    xml_codec c;
    OCTETSTRING os;
    int result = c.encode(msg, os);
    loggers::get_instance().log_msg("fx__enc__PullRequest: os: ", os);

    // Remove XML header added by the XML codec.
    OCTETSTRING h = char2oct("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n");
    os = OCTETSTRING(os.lengthof() - h.lengthof(), static_cast<const unsigned char*>(os) + h.lengthof());
    loggers::get_instance().log_msg("fx__enc__PullRequest: os: ", os);

    return oct2bit(os);
  }

  INTEGER fx__dec__PullRequest__1(BITSTRING &b, http__www__cise__eu__servicemodel__v1__message::PullRequest& p) { // FIXME Use enc/dec TITAN function external function f_enc_value(in Value x) return bitstring with { extension "prototype(convert) encode(abc)" }
    loggers::get_instance().log(">>> fx__dec__PullRequest");

    LibHttp__XmlMessageBodyTypes::XmlBody msg;
    xml_codec c;
    OCTETSTRING is = bit2oct(b);
    params parms;
    parms["decode_str"] = std::string(static_cast<const unsigned char *>(is), is.lengthof() + static_cast<const unsigned char *>(is));
    if (c.decode(is, msg, &parms) == -1) {
      loggers::get_instance().warning("fx__dec__PullRequest: -1 result code was returned");
      return -1;
    }

    p = msg.msg().pull__request();

    return 0;
  }

  BITSTRING fx__enc__PullResponse__1(const http__www__cise__eu__servicemodel__v1__message::PullResponse& p) { // FIXME Use enc/dec TITAN function external function f_enc_value(in Value x) return bitstring with { extension "prototype(convert) encode(abc)" }
    loggers::get_instance().log(">>> fx__enc__PullResponse");

    LibHttp__XmlMessageBodyTypes::XmlBody msg;
    msg.msg().pull__response() = p;
    msg.raw().set_to_omit();
    xml_codec c;
    OCTETSTRING os;
    int result = c.encode(msg, os);
    loggers::get_instance().log_msg("fx__enc__PullResponse: os: ", os);

    // Remove XML header added by the XML codec.
    OCTETSTRING h = char2oct("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n");
    os = OCTETSTRING(os.lengthof() - h.lengthof(), static_cast<const unsigned char*>(os) + h.lengthof());
    loggers::get_instance().log_msg("fx__enc__PullResponse: os: ", os);

    return oct2bit(os);
  }

  INTEGER fx__dec__PullResponse__1(BITSTRING &b, http__www__cise__eu__servicemodel__v1__message::PullResponse& p) { // FIXME Use enc/dec TITAN function external function f_enc_value(in Value x) return bitstring with { extension "prototype(convert) encode(abc)" }
    loggers::get_instance().log(">>> fx__dec__PullResponse");

    LibHttp__XmlMessageBodyTypes::XmlBody msg;
    xml_codec c;
    OCTETSTRING is = bit2oct(b);
    params parms;
    parms["decode_str"] = std::string(static_cast<const unsigned char *>(is), is.lengthof() + static_cast<const unsigned char *>(is));
    if (c.decode(is, msg, &parms) == -1) {
      loggers::get_instance().warning("fx__dec__PullResponse: -1 result code was returned");
      return -1;
    }

    p = msg.msg().pull__response();

    return 0;
  }

  BITSTRING fx__enc__Feedback__1(const http__www__cise__eu__servicemodel__v1__message::Feedback& p) { // FIXME Use enc/dec TITAN function external function f_enc_value(in Value x) return bitstring with { extension "prototype(convert) encode(abc)" }
    loggers::get_instance().log(">>> fx__enc__Feedback");

    LibHttp__XmlMessageBodyTypes::XmlBody msg;
    msg.msg().feedback() = p;
    msg.raw().set_to_omit();
    xml_codec c;
    OCTETSTRING os;
    int result = c.encode(msg, os);
    loggers::get_instance().log_msg("fx__enc__Feedback: os: ", os);

    // Remove XML header added by the XML codec.
    OCTETSTRING h = char2oct("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n");
    os = OCTETSTRING(os.lengthof() - h.lengthof(), static_cast<const unsigned char*>(os) + h.lengthof());
    loggers::get_instance().log_msg("fx__enc__Feedback: os: ", os);

    return oct2bit(os);
  }

  INTEGER fx__dec__Feedback__1(BITSTRING &b, http__www__cise__eu__servicemodel__v1__message::Feedback& p) { // FIXME Use enc/dec TITAN function external function f_enc_value(in Value x) return bitstring with { extension "prototype(convert) encode(abc)" }
    loggers::get_instance().log(">>> fx__dec__Feedback");

    LibHttp__XmlMessageBodyTypes::XmlBody msg;
    xml_codec c;
    OCTETSTRING is = bit2oct(b);
    params parms;
    parms["decode_str"] = std::string(static_cast<const unsigned char *>(is), is.lengthof() + static_cast<const unsigned char *>(is));
    if (c.decode(is, msg, &parms) == -1) {
      loggers::get_instance().warning("fx__dec__Feedback: -1 result code was returned");
      return -1;
    }

    p = msg.msg().feedback();

    return 0;
  }

} // End of namespace LibCise__Functions