#!/bin/bash

#set -e
set -vx

echo -e "*****************************\n* Checkout cise_devel sources\n*****************************\n"
mkdir -p ${HOME}/dev && cd ${HOME}/dev || exit 1

git clone --recurse-submodules --branch stf637 --single-branch https://forge.etsi.org/rep/cdm/cise-data-model cise_devel || exit 1
cd ${HOME}/dev/cise_devel/titan-test-system-framework
git checkout devel || exit 1

echo -e "*****************************\n* Set up environment\n*****************************\n"
cd ${HOME}
ln -sf ${HOME}/dev/cise_devel/scripts/devenv.bash.ubuntu ${HOME}/devenv.bash || exit 1
. ${HOME}/devenv.bash

echo -e "*****************************\n* Apply patched \n*****************************\n"
cd ${HOME}/dev/cise_devel
cp ./ttcn/patch_lib_common_titan/module.mk ./ttcn/LibCommon/ || exit 1
cp ./ttcn/patch_lib_common_titan/ttcn/*.ttcn ./ttcn/LibCommon/ttcn || exit 1

cd ./titan-test-system-framework/ttcn/LibHttp/
ln -sf module_cise.mk module.mk || exit 1

echo -e "*****************************\n* Build CISE test suite\n*****************************\n"
cd ${HOME}/dev/cise_devel
export ATS=AtsCise
make || exit 1
rm -fr ./build || exit 1

cd ./etc/AtsCise
ln -sf AtsCise_Cnit.cf_ AtsCise.cfg || exit 1

echo -e "*****************************\n* Change sudo in command line\n*****************************\n"
cd ${HOME}/dev/cise_devel/scripts
sed --in-place 's/sudo/echo "etsi" \| sudo -S/' ./run_mtc.bash || exit 1
sed --in-place 's/sudo/echo "etsi" \| sudo -S/' ./run_ptcs.bash || exit 1

cd ${HOME}/dev/cise_devel
