#!/bin/bash
set -exo pipefail

cd "$(dirname ${BASH_SOURCE})"

PRJ=cise-data-model
docker run --rm -it \
        -w $HOME/dev/$PRJ \
        -e GEN_DIR=$HOME/dev/$PRJ \
        -e ATS=$ATS \
        -u "$(id -u):$(id -g)" \
        -v "${PWD}/../..:$HOME/dev/$PRJ" \
        -p 0.0.0.0:8888:8888 \
        --mount type=bind,source=$HOME/var,target=/home/etsi/var,readonly \
        --entrypoint $HOME/dev/$PRJ/virtualization/docker/docker-entrypoint.sh \
        alpine-cise:latest "$@"
